/* Copyright (c) 2007 by IBM Corporation */

dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.requireLocalization("zero", "g11n");

dojo.provide("zero.form.common.components.NlsMixin");

dojo.require("zero.form.common.components.UidMixin");

dojo.declare(
    "zero.form.common.components.NlsMixin",zero.form.common.components.UidMixin,
    {
        data: {__initialized: false},

        constructor: function() 
        {
        	zero.form.common.components.NlsMixin.superclass.constructor.apply(this,arguments);
        	
			if(!this.data.__initialized)
			{
				this.data.nlsStrings = dojo.i18n.getLocalization("zero", "g11n");
				this.data.__initialized = true;		
			}
        },
	
		/**
		 * 
		 * @param {Object} key - the name of the key in the nls file
		 * @param {Object} substituteValues - either an array or an object with the values to replace the dojo replacement markers in the string that is
		 * returned from the nls file
		 */
		getString: function(key, substituteValues)
		{
			var str = this.data.nlsStrings[key];
			return (substituteValues)?dojo.string.substitute(str,substituteValues):str;
		}
    });
