dojo.provide("zero.form.widget.FieldWrapper");

dojo.require("dijit._Templated");
dojo.require("zero.form.common.components.BaseWrapper");
dojo.require("zero.form.widget.field.TextField");
dojo.require("zero.form.widget.field.NumberField");
dojo.require("zero.form.widget.field.CheckboxField");
dojo.require("zero.form.widget.field.DateField");
dojo.require("zero.form.widget.field.TimeField");
dojo.require("zero.form.widget.field.ComboBoxField");
dojo.require("zero.form.widget.FieldWrapperMixin");

dojo.declare("zero.form.widget.FieldWrapper",
             [zero.form.common.components.BaseWrapper, zero.form.widget.FieldWrapperMixin, dijit._Templated], {

		widgetsInTemplate:true,
		templatePath: dojo.moduleUrl("zero","form/widget/templates/field-wrapper.html"),
		
		getTypeOfWidget: function(typeAtJsonFile)
		{
			if ("Text" == typeAtJsonFile)
			{
				return "zero.form.widget.field.TextField";
			}
			else if("Number" == typeAtJsonFile)
			{
				return "zero.form.widget.field.NumberField";
				
			}
			else if("Checkbox" == typeAtJsonFile)
			{
				return "zero.form.widget.field.CheckboxField";
			}
			else if("Date" == typeAtJsonFile)
			{
				return "zero.form.widget.field.DateField";
			}
			else if("Time" == typeAtJsonFile)
			{
				return "zero.form.widget.field.TimeField";
			}
			else if("Select" == typeAtJsonFile)
			{
				return "zero.form.widget.field.ComboBoxField";
			}
			else
			{
				return "zero.form.widget.field.TextField";
			}
			
		},
		
		
		onSetDescription: function(pDescription)
		{
			this.tableNode.title = (pDescription) ? pDescription : "";
		},
		
		onSetTitle: function(pTitle)
		{
			this.titleNode.innerHTML = (pTitle) ? pTitle + ":" : "";
		},
			
		onSetHint: function(pHint)
		{
			this.hintNode.innerHTML = (pHint) ? pHint : "";
		},
		
		onSetRequired: function(pRequired)
		{
			if (pRequired === true || pRequired === "true") {
				this.requiredNode.innerHTML = "*";
			}
			else {
				this.requiredNode.innerHTML = "&nbsp";
			}
		}
});